#property copyright "chinaski"
#property version   "1.00"
#property strict


static int __object_counter=0;
//----------------------------
//--jump_rec
//----------------------------
class jump_rec
{
public:
   jump_rec(const string                   name="RectLabel",         // label name
                        const int              x=10,                      // X coordinate
                        const int              y=10,                      // Y coordinate
                        const int              width=100,                 // width
                        const int              height=100,                // height
                        const color            back_clr=C'236,233,216',  // background color
                        const long             chart_ID=0,               // chart's ID                     
                        const int              sub_window=0,             // subwindow index
                        const ENUM_BORDER_TYPE border=BORDER_FLAT,     // border type
                        const ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER, // chart corner for anchoring
                        const color            border_clr=clrRed,               // flat border color (Flat)
                        const ENUM_LINE_STYLE  style=STYLE_SOLID,        // flat border style
                        const int              line_width=1,             // flat border width
                        const bool             back=false,               // in the background
                        const bool             selection=true,          // highlight to move
                        const bool             hidden=true,              // hidden in the object list
                        const long             z_order=2,               //           priority for mouse click
                        bool                   redraw=false
                        )     
                        
     {
   //--- reset the error value
      ResetLastError();
      ++__object_counter;
      _name=StringFormat("rec_%s_%d",name,__object_counter);
   //--- create a rectangle label
     if(!ObjectCreate(chart_ID,_name,OBJ_RECTANGLE_LABEL,sub_window,0,0))
     //if(!ObjectCreate(chart_ID,_name,OBJ_RECTANGLE,sub_window,0,0))
     {
         Print(__FUNCTION__,
               "#error: failed to create a rectangle label! ec=",GetLastError());       
        
     }
     else
     {
  
     
      //--- set label coordinates
         ObjectSetInteger(chart_ID,_name,OBJPROP_XDISTANCE,x);
         ObjectSetInteger(chart_ID,_name,OBJPROP_YDISTANCE,y);
      //--- set label size
         ObjectSetInteger(chart_ID,_name,OBJPROP_XSIZE,width);
         ObjectSetInteger(chart_ID,_name,OBJPROP_YSIZE,height);
      //--- set background color
//       uchar alpha=0x55;
     // uint  back_clr_transe=ColorToARGB(back_clr,alpha);
     // ObjectSetInteger(OBJPROP_COLOR
      
         ObjectSetInteger(chart_ID,_name,OBJPROP_BGCOLOR,back_clr);
      //   ObjectSetInteger(chart_ID,name,OBJPROP_BGCOLOR,back_clr_transe);
      //--- set border type
         ObjectSetInteger(chart_ID,_name,OBJPROP_BORDER_TYPE,border);
      //--- set the chart's corner, relative to which point coordinates are defined
         ObjectSetInteger(chart_ID,_name,OBJPROP_CORNER,corner);
      //--- set flat border color (in Flat mode)
         ObjectSetInteger(chart_ID,_name,OBJPROP_COLOR,border_clr);
      //--- set flat border line style
         ObjectSetInteger(chart_ID,_name,OBJPROP_STYLE,style);
      //--- set flat border width
         ObjectSetInteger(chart_ID,_name,OBJPROP_WIDTH,line_width);
      //--- display in the foreground (false) or background (true)
         ObjectSetInteger(chart_ID,_name,OBJPROP_BACK,back);
      //--- enable (true) or disable (false) the mode of moving the label by mouse
         ObjectSetInteger(chart_ID,_name,OBJPROP_SELECTABLE,selection);
         ObjectSetInteger(chart_ID,_name,OBJPROP_SELECTED,selection);
      //--- hide (true) or display (false) graphical object name in the object list
         ObjectSetInteger(chart_ID,_name,OBJPROP_HIDDEN,hidden);
      //--- set the priority for receiving the event of a mouse click in the chart
         ObjectSetInteger(chart_ID,_name,OBJPROP_ZORDER,z_order);
      //--- successful execution
        if(redraw == true)
            ChartRedraw();
       
     }
   }  
   virtual ~jump_rec()
   {
      ObjectDelete(0,_name);
   }
protected:
   string _name;
};


jump_rec* prec=NULL;


//+------------------------------------------------------------------+
int OnInit()
{
   ChartSetInteger(0,CHART_EVENT_MOUSE_MOVE,1);
   prec=new jump_rec("rec_label",50,50,200,200);
   return 0;
}
void OnDeinit(const int reason)
{
   delete prec;
}
//+------------------------------------------------------------------+
void OnTimer()
  {
  }
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{
      if(id == CHARTEVENT_OBJECT_DRAG)
		{
			Print("drag");
		}
}
//+------------------------------------------------------------------+